<?php
#--------------------------------#
#  アップロードファイルチェック  #
#--------------------------------#
function check_uploaded_image(){

	$arr = array();
	if(empty($_FILES['upfile']['name'])){	return $arr; }

	// ファイルサイズチェック
	if($_FILES['upfile']['size'] > ALLOW_MAX_UPLOAD){	error("ファイルサイズが".ceil(ALLOW_MAX_UPLOAD/1024)."KBを超えています、LINE=".__LINE__); }

	// 拡張子チェック
	if(!preg_match(ALLOW_UPFILE_EXTENSIONS, $_FILES['upfile']['name'], $matches)){
		error("許可している拡張子ではありません、LINE=".__LINE__);
	}
	// アップロードファイルのStringチェック
	check_str_upfile();
	// ファイルフォーマットチェック
	if(preg_match('/(jpg|gif|png|jpeg)$/i', $matches[1])){
		$arr = getimagesize($_FILES['upfile']['tmp_name']);
		if(!$arr){	error("画像ファイルではありません、LINE=".__LINE__); }
		if($matches[1] == "jpeg"){	$matches[1] = "jpg"; }
		$arr['extention'] = $matches[1];
		get_resize_image($arr);
	}

	return $arr;
}
#--------------------#
#  画像アップロード  #
#--------------------#
function do_upload_image($id,&$img_arr){

	if(empty($_FILES['upfile']['name']) || empty($img_arr)){	return; }
	$filename = PATH_IMG . $id . "." . $img_arr['extention'];
	if(file_exists($filename)){
		if(!unlink($filename)){	error("unlink Error: ".t2h($filename)); }
	}
	if(intval(IMG_REMAKE) == 1){
		remake_upload_image($_FILES['upfile']['tmp_name'],$filename,$img_arr['2']);
	}else{
		if(!move_uploaded_file($_FILES['upfile']['tmp_name'], $filename)){
			error("ファイルアップロード中にエラーが発生しました、LINE=".__LINE__);
		}else{
			chmod($filename, 0606);
		}
	}
	// サムネイル作成
	if(!$img_arr['resize']){	return; }
	$thumbnail = PATH_IMG . $id . "_s." . $img_arr['extention'];
	make_thumbnail($filename,$thumbnail,$img_arr['2'],$img_arr['0'],$img_arr['1'],$img_arr['width_s'],$img_arr['height_s']);
}
#-----------------------------#
#  アップロードファイル再作成 #
#-----------------------------#
function remake_upload_image($upfile,&$filename,$type){

	switch($type):
		case '1':	// gif形式
			// 元画像ファイルの読み込み
			$img = imagecreatefromgif($upfile);
			if($img){
				// 画像再作成
				imagegif($img, $filename);
				chmod($filename, 0606);
				imagedestroy($img);
			}else{
				error("アップロードファイル再作成に失敗しました、LINE=".__LINE__);
			}
			break;
		case '2':	// jpg形式
			// 元画像ファイルの読み込み
			$img = imagecreatefromjpeg($upfile);
			if($img){
				// 画像再作成
				imagejpeg($img, $filename);
				chmod($filename, 0606);
				imagedestroy($img);
			}else{
				error("アップロードファイル再作成に失敗しました、LINE=".__LINE__);
			}
			break;
		case '3':	// png形式
			// 元画像ファイルの読み込み
			$img = imagecreatefrompng($upfile);
			if($img){
				// 画像再作成
				imagepng($img, $filename);
				chmod($filename, 0606);
				imagedestroy($img);
			}else{
				error("アップロードファイル再作成に失敗しました、LINE=".__LINE__);
			}
			break;
		default:
			list($name, $extension) = split("\.", $filename);
			error("「".t2h($filename)."」は".t2h($extension)."形式のファイルではありません、LINE=".__LINE__);
			break;
	endswitch;
}
#-------------------------#
#  サムネイルファイル作成 #
#-------------------------#
function make_thumbnail(&$filename,&$thumbnail,$type,$width,$height,$width_s,$height_s){

	switch($type):
		case '1':	// gif形式
			// 元画像ファイルの読み込み
			$img = imagecreatefromgif($filename);
			if($img){
				// サムネイル画像生成
				$newimg = imagecreatetruecolor($width_s, $height_s);
				$black = imagecolorallocate($img, 0,0,0);
				// 元画像をサムネイルにリサイズ
				imagecopyresized($newimg, $img, 0, 0, 0, 0, $width_s, $height_s, $width, $height);
				imagegif($newimg, $thumbnail);
				chmod($thumbnail, 0606);
				imagedestroy($img);
			}else{
				error("サムネイルファイル作成に失敗しました、LINE=".__LINE__);
			}
			break;
		case '2':	// jpg形式
			// 元画像ファイルの読み込み
			$img = imagecreatefromjpeg($filename);
			if($img){
				// サムネイル画像生成
				$newimg = imagecreatetruecolor($width_s, $height_s);
				$black = imagecolorallocate($img, 0,0,0);
				// 元画像をサムネイルにリサイズ
				imagecopyresized($newimg, $img, 0, 0, 0, 0, $width_s, $height_s, $width, $height);
				imagejpeg($newimg, $thumbnail);
				chmod($thumbnail, 0606);
				imagedestroy($img);
			}else{
				error("サムネイルファイル作成に失敗しました、LINE=".__LINE__);
			}
			break;
		case '3':	// png形式
			// 元画像ファイルの読み込み
			$img = imagecreatefrompng($filename);
			if($img){
				// サムネイル画像生成
				$newimg = imagecreatetruecolor($width_s, $height_s);
				$black = imagecolorallocate($img, 0,0,0);
				// 元画像をサムネイルにリサイズ
				imagecopyresized($newimg, $img, 0, 0, 0, 0, $width_s, $height_s, $width, $height);
				imagepng($newimg, $thumbnail);
				chmod($thumbnail, 0606);
				imagedestroy($img);
			}else{
				error("サムネイルファイル作成に失敗しました、LINE=".__LINE__);
			}
			break;
		default:
			list($name, $extension) = split("\.", $filename);
			error("「".t2h($filename)."」は".t2h($extension)."形式のファイルではありません、LINE=".__LINE__);
			break;
	endswitch;
}
#------------------------#
#  縮小画像の縦横比取得  #
#------------------------#
function get_resize_image(&$arr){

	$arr['resize'] = false;
	$width_org = (int)$arr['0'];
	$height_org = (int)$arr['1'];

	if($width_org <= IMG_W && $height_org <= IMG_H){
		$arr['width_s'] = $width_org;
		$arr['height_s'] = $height_org;
	}else{
		$width_calc = (int)(IMG_H / $height_org * $width_org);
		$height_calc = (int)(IMG_W / $width_org * $height_org);
		if($width_calc >= IMG_W && $height_calc < IMG_H){
			$arr['resize'] = true;
			$arr['width_s'] = IMG_W;
			$arr['height_s'] = $height_calc;
		}elseif($width_calc < IMG_W && $height_calc >= IMG_H){
			$arr['resize'] = true;
			$arr['width_s'] = $width_calc;
			$arr['height_s'] = IMG_H;
		}
	}
}
#---------------------------------------#
#  アップロードファイルのStringチェック #
#---------------------------------------#
function check_str_upfile(){

	$img = file_get_contents($_FILES['upfile']['tmp_name']);
	if(preg_match('/<\?php/', $img)){
		error("PHPの開始タグが含まれています、LINE=".__LINE__);
	}
	if(preg_match('/<script/i', $img)){
		error("scriptタグが含まれています、LINE=".__LINE__);
	}
}
?>